public class Point implements Cloneable {
    public int x, y;    
    public boolean equals(Object o) {
        if (o == null) return false;
        Point p = (Point)o;
        return x == p.x && y == p.y;
    }
    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }
}
